%
%
%  Kalibrierung Soundkarte
%
%   Hochschule Mnchen
%   Labor fr Maschinendynmik
%   Dipl.-Ing. Armin Rohnen LbA
%
%   Mnchen, 18. Januar 2017
%
%   -----------------------------------------------------------------------

%
%
% Vorbereitungen fr die Messung
%%

fs = 48000;                         % Abtastrate

[messgeraet, hpib, fs] = setup(fs);

messung.beschreibung1 = 'Kalibrierung RME Fireface 802';
messung.beschreibung2 = ' Analog in 1 bis 8';
messung.datum = '18. Januar 2017';
messung.Pruefer = 'Dipl.-Ing. Armin Rohnen LbA';
messung.fs = fs;

                                    %
                                    % Messgerte konfigurieren
                                    % 

                                    %
                                    % Kalibrierstufen
                                    %
amplitude = [10 20 30 50 70];       % Basis Amplitudenwerte
amplitude_multi = [1 10 100];       % Multiplikatoren fr die Amplituden
frequenzen = [1 2 3 5 7];           % Basis Frequenzen
frequenzen_multi = [1 20 100 1000 10000];

count = 0;                          % Schleifenzhler
disp('Messung startet');

for fm = 1:length(frequenz_multi)
    for f=1:length(frequenzen)
        for am=1:length(amplitude_multi)
            for a=1:length(amplitude)
                
                count = count +1;
                
                sollamplitude = amplitude(a)*amplitude_multi(am);
                sollfrequenz = frequenz(f) * frequenz_multi(fm);
                
                fprintf(hpib,'FRA' num2str(sollfrequenz) 'HZ');     % Frequenz
                fprintf(hpib,['APA' num2str(sollamplitude) 'MV']);  % Amplitude
                
                [Data, Time] = messgeraet.startForeground;
                                    % Messung durchfhren
                
                fprintf(hpib,['APA' num2str(0) 'MV']);

                messung.messwerte(count).Data = Data;
                messung.messwerte(count).Time = Time;
                messung.messwerte(count).sollamplitude = sollamplitude;
                messung.messwerte(count).sollfrequenz = sollfrequenz;
                
            end;
        end;
    end;
end;

disp('Messung beendet bitte das Ergebnis abspeichern');